-- FOOTSTEPS.LUA
--
-- Original fork of the Modern Sonic's footstep engine available at:
-- https://mb.srb2.org/addons/footsteps.1378/
--
-- Modified by LeonardoTheMutant for LTM's Murder Mystery

local footmarksCVAR = CV_FindVar("mm_footmarks")

freeslot(
	"sfx_sowoln", "sfx_socoln", "sfx_sodiln", "sfx_someln", "sfx_sogrln", "sfx_sowaln", "sfx_soglln", "sfx_sosnln", "sfx_sosaln", "sfx_soclln",
	"sfx_sowobr", "sfx_socobr", "sfx_sodibr", "sfx_somebr", "sfx_sogrbr", "sfx_sowabr", "sfx_soglbr",
	"sfx_soco1", "sfx_soco2", "sfx_soco3", "sfx_soco4",
	"sfx_sodi1", "sfx_sodi2", "sfx_sodi3", "sfx_sodi4",
	"sfx_sogl1", "sfx_sogl2", "sfx_sogl3",
	"sfx_sogr1", "sfx_sogr2", "sfx_sogr3", "sfx_sogr4",
	"sfx_some1", "sfx_some2", "sfx_some3", "sfx_some4",
	"sfx_sowa1", "sfx_sowa2", "sfx_sowa3", "sfx_sowa4",
	"sfx_sowo1", "sfx_sowo2", "sfx_sowo3", "sfx_sowo4",
	"sfx_sosn1", "sfx_sosn2", "sfx_sosn3", "sfx_sosn4",
	"sfx_sosa1", "sfx_sosa2", "sfx_sosa3", "sfx_sosa4",
	"sfx_socl1", "sfx_socl2", "sfx_socl3", "sfx_socl4"
)

if not SoundListInfo
	rawset(_G, "SoundListInfo", {})
end
if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end

sfxinfo[sfx_sowoln].caption="Wood landing"
sfxinfo[sfx_socoln].caption="Stone landing"
sfxinfo[sfx_sodiln].caption="Ground landing"
sfxinfo[sfx_someln].caption="Metal landing"
sfxinfo[sfx_sogrln].caption="Grass landing"
sfxinfo[sfx_sowaln].caption="Liquid landing"
sfxinfo[sfx_soglln].caption="Glass landing"
sfxinfo[sfx_sosnln].caption="Snow landing"
sfxinfo[sfx_soclln].caption="Cloth landing"

sfxinfo[sfx_sowobr].caption="Wood skidding"
sfxinfo[sfx_socobr].caption="Stone skidding"
sfxinfo[sfx_sodibr].caption="Ground Skidding"
sfxinfo[sfx_somebr].caption="Metal skidding"
sfxinfo[sfx_sogrbr].caption="Grass skidding"
sfxinfo[sfx_sowabr].caption="Liquid skidding"
sfxinfo[sfx_soglbr].caption="Glass skidding"

sfxinfo[sfx_soco1].caption="Stone steps"
sfxinfo[sfx_soco2].caption="Stone steps"
sfxinfo[sfx_soco3].caption="Stone steps"
sfxinfo[sfx_soco4].caption="Stone steps"

sfxinfo[sfx_sodi1].caption="Ground steps"
sfxinfo[sfx_sodi2].caption="Ground steps"
sfxinfo[sfx_sodi3].caption="Ground steps"
sfxinfo[sfx_sodi4].caption="Ground steps"

sfxinfo[sfx_sogl1].caption="Glass steps"
sfxinfo[sfx_sogl2].caption="Glass steps"
sfxinfo[sfx_sogl3].caption="Glass steps"

sfxinfo[sfx_sogr1].caption="Grass steps"
sfxinfo[sfx_sogr2].caption="Grass steps"
sfxinfo[sfx_sogr3].caption="Grass steps"
sfxinfo[sfx_sogr4].caption="Grass steps"

sfxinfo[sfx_some1].caption="Metal steps"
sfxinfo[sfx_some2].caption="Metal steps"
sfxinfo[sfx_some3].caption="Metal steps"
sfxinfo[sfx_some4].caption="Metal steps"

sfxinfo[sfx_sowa1].caption="Liquid steps"
sfxinfo[sfx_sowa2].caption="Liquid steps"
sfxinfo[sfx_sowa3].caption="Liquid steps"
sfxinfo[sfx_sowa4].caption="Liquid steps"

sfxinfo[sfx_sowo1].caption="Wood steps"
sfxinfo[sfx_sowo2].caption="Wood steps"
sfxinfo[sfx_sowo3].caption="Wood steps"
sfxinfo[sfx_sowo4].caption="Wood steps"

sfxinfo[sfx_sosn1].caption="Snow steps"
sfxinfo[sfx_sosn2].caption="Snow steps"
sfxinfo[sfx_sosn3].caption="Snow steps"
sfxinfo[sfx_sosn4].caption="Snow steps"

sfxinfo[sfx_sosa1].caption="Sand steps"
sfxinfo[sfx_sosa2].caption="Sand steps"
sfxinfo[sfx_sosa3].caption="Sand steps"
sfxinfo[sfx_sosa4].caption="Sand steps"

sfxinfo[sfx_socl1].caption="Cloth steps"
sfxinfo[sfx_socl2].caption="Cloth steps"
sfxinfo[sfx_socl3].caption="Cloth steps"
sfxinfo[sfx_socl4].caption="Cloth steps"

local soundinfolist={
	["sonic"]={
		["grass"]={
		  ["steps"]={sfx_sogr1, sfx_sogr2, sfx_sogr3, sfx_sogr4},
		  ["skid"]={sfx_sogrbr},
		  ["land"]={sfx_sogrln},
		},["metal"]={
		  ["steps"]={sfx_some1, sfx_some2, sfx_some3, sfx_some4},
		  ["skid"]={sfx_somebr},
		  ["land"]={sfx_someln},
		},["dirt"]={
		  ["steps"]={sfx_sodi1, sfx_sodi2, sfx_sodi3, sfx_sodi4},
		  ["skid"]={sfx_sodibr},
		  ["land"]={sfx_sodiln},
		},["snow"]={
		  ["steps"]={sfx_sosn1, sfx_sosn2, sfx_sosn3, sfx_sosn4},
		  ["skid"]={sfx_sodibr},
		  ["land"]={sfx_sosnln},
		},["cloth"]={
		  ["steps"]={sfx_socl1, sfx_socl2, sfx_socl3, sfx_socl4},
		  ["skid"]={sfx_sodibr},
		  ["land"]={sfx_soclln},
		},["sand"]={
		  ["steps"]={sfx_sosa1, sfx_sosa2, sfx_sosa3, sfx_sosa4},
		  ["skid"]={sfx_sodibr},
		  ["land"]={sfx_sosaln},
		},["wood"]={
		  ["steps"]={sfx_sowo1, sfx_sowo2, sfx_sowo3, sfx_sowo4},
		  ["skid"]={sfx_sowobr},
		  ["land"]={sfx_sowoln},
		},["stone"]={
		  ["steps"]={sfx_soco1, sfx_soco2, sfx_soco3, sfx_soco4},
		  ["skid"]={sfx_socobr},
		  ["land"]={sfx_socoln},
		},["water"]={
		  ["steps"]={sfx_sowa1, sfx_sowa2, sfx_sowa3, sfx_sowa4},
		  ["skid"]={sfx_sowabr},
		  ["land"]={sfx_sowaln},
		},["lava"]={
		  ["steps"]={sfx_sowa1, sfx_sowa2, sfx_sowa3, sfx_sowa4},
		  ["skid"]={sfx_sowabr},
		  ["land"]={sfx_sowaln},
		},["glass"]={
		  ["steps"]={sfx_sogl1, sfx_sogl2, sfx_sogl3},
		  ["skid"]={sfx_soglbr},
		  ["land"]={sfx_soglln},
		}
	}
}
for soundlist, soundinfo in pairs(soundinfolist)
	SoundListInfo[soundlist]=soundinfo
end
local flatsounds={ 
	["GFZROCKC"]="stone",
	["OLDGFZF1"]="dirt",
	["OLDGFZF2"]="grass",
	["OLDGFZF3"]="grass",
	["OLDGFZF4"]="stone",
	["GFZROCKA"]="stone",
	["GFZWAVEF"]="stone",
	["GFZFNCG"]="wood",
	["GFZFNCF"]="wood",
	["GFZFLR01"]="stone",
	["GFZFLR02"]="grass",
	["GFZFLR03"]="metal",
	["GFZFLR04"]="metal",
	["GFZFLR05"]="wood",
	["GFZFLR06"]="wood",
	["GFZFLR07"]="wood",
	["GFZFLR08"]="dirt",
	["GFZFLR09"]="wood",
	["GFZFLR10"]="grass",
	["GFZFLR11"]="stone",
	["GFZFLR12"]="stone",
	["GFZFLR13"]="wood",
	["GFZFLR14"]="stone",
	["GFZFLR15"]="stone",
	["GFZFLR16"]="stone",
	["GFZFLR17"]="stone",
	["GFZFLR18"]="wood",
	["GFZFLR19"]="wood",
	["GFZFLR20"]="stone",
	["GFZFLR21"]="grass",
	["GFZFLR22"]="grass",
	["GFZROCK"]="stone",
	["GFZGRSW"] ="grass",
	["THCOMPF1"]="metal",
	["THCOMPF2"]="metal",
	["THCOMPF3"]="metal",
	["THCOMPF4"]="metal",
	["THCOMPF5"]="metal",
	["THCOMPF6"]="metal",
	["THZGRS1"]="grass",
	["THZGRS2"]="grass",
	["TH2_SF1"]="stone",
	["TH2_SF2"]="stone",
	["TH2_SF3"]="stone",
	["COMP7A"]="metal",
	["COMP7B"]="metal",
	["THZELA1"]="metal",
	["THZELA2"]="metal",
	["THZELB1"]="metal",
	["THZELB2"]="metal",
	["THZELC1"]="metal",
	["THZELC2"]="metal",
	["THZELD1"]="metal",
	["THZELD2"]="metal",
	["THZELE1"]="metal",
	["THZELE2"]="metal",
	["THZELF1"]="metal",
	["THZELF2"]="metal",
	["THZELG1"]="metal",
	["THZELG2"]="metal",
	["THZELH1"]="metal",
	["THZELH2"]="metal",
	["THZELI1"]="metal",
	["THZELI2"]="metal",
	["THZELJ1"]="metal",
	["THZELJ2"]="metal",
	["THZFLR35"]="metal",
	["THZFLR36"]="metal",
	["THZREDP1"]="metal",
	["THZREDP2"]="metal",
	["THZGRYP1"]="metal",
	["THZGRYP2"]="metal",
	["F_metal1"]="metal",
	["F_metal2"]="metal",
	["THZ2FN1"]="stone",
	["THZ3DPF1"]="stone",
	["THZ3DPF2"]="stone",
	["THZ3DPF3"]="stone",
	["THZ3DPF4"]="stone",
	["THZ3DPFA"]="metal",
	["THZ3DPFB"]="metal",
	["THZ3DPFC"]="metal",
	["THZ3DPFD"]="metal",
	["THPIPEF1"]="metal",
	["THPIPEF2"]="metal",
	["STKBOXS1"]="metal",
	["STKBOXS2"]="metal",
	["STKBOXS3"]="metal",
	["STKBOXS4"]="metal",
	["STKBOXT1"]="metal",
	["STKBOXT2"]="metal",
	["STKBOXT3"]="metal",
	["STKBOXT4"]="metal",
	["STKBOXK1"]="metal",
	["STKBOXK2"]="metal",
	["STKBOXK3"]="metal",
	["STKBOXK4"]="metal",
	["THZBOX"]="metal",
	["THZBOX01"]="metal",
	["THZBOX02"]="metal",
	["THZBOX03"]="metal",
	["THZBOXF1"]="metal",
	["THZBOXF2"]="metal",
	["THZBOXF3"]="metal",
	["THZBOXF4"]="metal",
	["THZFLR01"]="metal",
	["THZFLR02"]="metal",
	["THZFLR03"]="metal",
	["THZFLR04"]="metal",
	["THZFLR05"]="metal",
	["THZFLR06"]="metal",
	["THZFLR07"]="metal",
	["THZFLR08"]="metal",
	["THZFLR09"]="metal",
	["THZFLR10"]="metal",
	["THZFLR11"]="metal",
	["THZFLR12"]="metal",
	["THZFLR13"]="metal",
	["THZFLR14"]="metal",
	["THZFLR15"]="metal",
	["THZFLR16"]="metal",
	["THZFLR17"]="metal",
	["THZFLR18"]="metal",
	["THZFLR19"]="metal",
	["THZFLR20"]="metal",
	["THZFLR21"]="metal",
	["THZFLR22"]="metal",
	["THZFLR23"]="metal",
	["THZFLR24"]="metal",
	["THZFLR25"]="metal",
	["THZFLR26"]="metal",
	["THZFLR27"]="metal",
	["THZFLR28"]="metal",
	["THZFLR29"]="metal",
	["THZFLR30"]="stone",
	["THZFLR31"]="metal",
	["THZFLR32"]="metal",
	["THZFLR33"]="metal",
	["THZFLR34"]="metal",
	["THZFLR35"]="metal",
	["THZFLR36"]="metal",
	["THZFLR37"]="metal",
	["THZ2FN2"]="metal",
	["THZ2FN3"]="metal",
	["THZ2FN4"]="metal",
	["THZ2FN4B"]="metal",
	["THZ2FN5"]="metal",
	["THZ2FN5B"]="metal",
	["THZ2FN6"]="metal",
	["THZ2FN6B"]="metal",
	["THZ2FN7"]="metal",
	["THZ2FN7B"]="metal",
	["THZ2FN8"]="metal",
	["THZ2FN9"]="metal",
	["THZ2WN5"]="metal",
	["THZ2WN5B"]="metal",
	["THZ2WN6"]="metal",
	["THZ2WN6B"]="metal",
	["THZ2WN7"]="metal",
	["THZ2WN7B"]="metal",
	["THZ2WN8"]="metal",
	["THZ2WN8B"]="metal",
	["THZ2CN1"]="metal",
	["THZ2CN1B"]="metal",
	["THZ2CN2"]="metal",
	["THZ2CN2B"]="metal",
	["THZ2CN3"]="metal",
	["THZ2CN3B"]="metal",
	["THZ2CN4"]="metal",
	["THZ2CN4B"]="metal",
	["THZ2CN5"]="metal",
	["THZ2CN5B"]="metal",
	["THZ2CN6"]="metal",
	["THZ2CN6B"]="metal",
	["THZ2CN7"]="metal",
	["THZ2CN7B"]="metal",
	["THZ2CN8"]="metal",
	["THZ2CN8B"]="metal",
	["THZLIG1"]="metal",
	["THZLIG2"]="metal",
	["THZLITS"]="metal",
	["THROCKF"]="metal",
	["THROCKF"]="stone",
	["THROCKF2"]="stone",
	["THROCKLF"]="stone",
	["THTILEF1"]="metal",
	["ALTBOXF1"]="metal",
	["ALTBOXF2"]="metal",
	["ALTBOXF3"]="metal",
	["ALTBOXF4"]="metal",
	["BOXWARN2"]="metal",
	["BOXWARNG"]="metal",
	["PIPE2F"]="metal",
	["PIPE3F"]="metal",
	["THDIRT"]="dirt",
	["STEEL"]="metal",
	["STEEL2"]="metal",
	["STEEL3"]="metal",
	["STEEL01"]="metal",
	["STEEL02"]="metal",
	["STEEL03"]="metal",
	["STEEL04"]="metal",
	["STEEL05"]="metal",
	["STEEL06"]="metal",
	["STEEL07"]="metal",
	["STEEL08"]="metal",
	["STEEL08B"]="metal",
	["DSZ10"]="stone",
	["DSZ11"]="stone",
	["DSZFLR01"]="stone",
	["DSZFLR02"]="stone",
	["DSZFLR03"]="stone",
	["DSZFLR04"]="dirt",
	["DSZFLR05"]="dirt",
	["DSZFLR06"]="dirt",
	["DSZFLR07"]="stone",
	["DSZFLR08"]="stone",
	["DSZFLR09"]="stone",
	["DSZFLR10"]="stone",
	["DSZFLR11"]="stone",
	["DSZFLR12"]="stone",
	["DSZFLR13"]="stone",
	["DSZFLR14"]="stone",
	["DSZFLR15"]="stone",
	["DSZFLR16"]="stone",
	["DSZFLR17"]="stone",
	["DSZFLR18"]="stone",
	["DSZFLR19"]="stone",
	["DSZRCKF1"]="stone",
	["DSZRCKF2"]="stone",
	["DSZRCKF3"]="stone",
	["DSWHEELF"]="stone",
	["DSBLOCK1"]="stone", 
	["DSBLOCK2"]="stone",
	["DSBLOCK3"]="stone", 
	["DSBLOCK4"]="stone",
	["DSCYAN1"]="stone",
	["DSCYAN3"]="stone",
	["DSDEBRIS"]="stone", 
	["DSFLOOR1"]="stone",
	["DSFLOOR2"]="stone",
	["DSKNUXB1"]="stone",
	["DSLTILE1"]="stone",
	["DSLTILE2"]="stone",
	["DSNOCLM2"]="stone",
	["DSRFLOR1"]="stone",
	["DSRFLOR2"]="stone",
	["DSROCK_1"]="dirt",
	["DSROCK_2"]="stone",
	["DSSBFLR1"]="dirt",
	["DSSBFLR2"]="water",
	["DSSBFLR3"]="water",
	["DSSBFLR4"]="water",
	["DSSKSEA1"]="water",
	["DSSKSEA2"]="water",
	["DSSWIT1"]="stone",
	["DSSWIT2"]="stone",
	["DSSWIT3"]="stone",
	["DSSWIT4"]="stone",
	["DSSWIT5"]="stone",
	["DSSWIT6"]="stone",
	["DSTILEN1"]="stone",
	["DSTILE_1"]="stone",
	["DSTRACK1"]="stone",
	["DSTRACK2"]="stone",
	["DSWATER1"]="water",
	["DSWATER2"]="water",
	["CESTOND1"]="stone",
	["CESTOND2"]="stone",
	["CESTOND3"]="stone",
	["CESTOND4"]="stone",
	["CESTOND5"]="stone",
	["CESTOND6"]="stone",
	["CESTOND7"]="stone",
	["CESTOND8"]="stone",
	["CESTOND9"]="stone",
	["CESTONE"]="stone",
	["CESTONE1"]="stone",
	["CESTONE2"]="stone",
	["CESTONE3"]="stone",
	["CESTONE4"]="stone",
	["CESTONE5"]="stone",
	["CESTONE6"]="stone",
	["CESTONE7"]="stone",
	["CESTONE8"]="stone",
	["CESTONE9"]="stone",
	["BRIDGEA1"]="stone",
	["BRIDGEA2"]="stone",
	["BRIDGEA3"]="stone",
	["OLDCEZF1"]="stone",
	["CEBRAMBL"]="grass",
	["CEZFLR01"]="stone",
	["CEZFLR02"]="grass",
	["CEZFLR03"]="grass",
	["CEZFLR04"]="stone",
	["CEZFLR05"]="grass",
	["CEZFLR06"]="stone",
	["CEZFLR07"]="wood",
	["CEZFLR08"]="wood",
	["CEZFLR09"]="stone",
	["CEZFLR10"]="wood",
	["CEZFLR11"]="wood",
	["CEZFLR12"]="grass",
	["CEZFLR13"]="grass",
	["CEZROCKA"]="stone",
	["CEZDRTF0"]="dirt",
	["CEZGRS0"]="grass",
	["CEZGRS1"]="grass",
	["CEZGRS2"]="dirt",
	["CEZLEAF0"]="grass",
	["CEZRCKF0"]="stone",
	["LIBFLR1"]="wood",
	["LIBFLR2"]="wood",
	["DMAFLAT1"]="stone",
	["DMAFLAT2"]="stone",
	["DMAFLAT3"]="stone",
	["DMAFLAT4"]="stone",
	["DMAFLAT5"]="stone",
	["DMAFLAT6"]="stone",
	["DMAFLAT7"]="stone",
	["DMAFLAT8"]="stone",
	["CETILE1"]="stone",
	["CETILE1B"]="stone",
	["CETILE2"]="stone",
	["CETILE2B"]="stone",
	["CETILE3"]="stone",
	["CETILD1"]="stone",
	["CETILD1B"]="stone",
	["CETILD2"]="stone",
	["CETILD2B"]="stone",
	["CETILD3"]="stone",
	["CETILC1"]="stone",
	["CETILC2"]="stone",
	["CETILB1"]="stone",
	["CETILB1B"]="stone",
	["CETILB2"]="stone",
	["CETILB2B"]="stone",
	["CETILB3"]="stone",
	["CASTLE2"]="wood",
	["CASTLE3"]="wood",
	["CASTLE4"]="wood",
	["CASTLE5"]="wood",
	["CASTLED"]="wood",
	["CASTLEF"]="wood",
	["CASTLEG"]="wood",
	["CASTLEE"]="wood",
	["CASTLEFF"]="metal",
	["CEZBRWL1"]="dirt",
	["CESBCA00"]="stone",
	["CESBFO01"]="stone",
	["CEBURST1"]="stone",
	["CEBURST2"]="stone",
	["CEBURST3"]="stone",
	["CEVBARF"]="grass",
	["CESTP1E"]="stone",
	["CESTP1N"]="stone",
	["CESTP1W"]="stone",
	["CESTP1S"]="stone",
	["CECRPTR"]="cloth",
	["CECRPTRE"]="cloth",
	["CECRPTRS"]="cloth",
	["CECRPTRW"]="cloth",
	["CECRPTRN"]="cloth",
	["CECRPTG1"]="cloth",
	["CECRPTG2"]="cloth",
	["CECRPTGN"]="cloth",
	["CECRPTGS"]="cloth",
	["CECRPTGW"]="cloth",
	["CECRPTGE"]="cloth",
	["CECRPTB"]="cloth",
	["CECRPTBE"]="cloth",
	["CECRPTBS"]="cloth",
	["CECRPTBW"]="cloth",
	["CECRPTBN"]="cloth",
	["CETILL1"]="stone",
	["CETILL1B"]="stone",
	["CETILL2"]="stone",
	["CETILL2B"]="stone",
	["CETILL3"]="stone",
	["CETILL4"]="stone",
	["CETILL5"]="stone",
	["CETILL6"]="stone",
	["CEZCLOUD"]="stone",
	["CEZGRS10"]="grass",
	["CEZGRS11"]="grass",
	["CEZPLD1F"]="dirt",
	["CEZWATR0"]="water",
	["CEZWATR1"]="water",
	["SLF_174"]="stone",
	["CETILE4"]="stone",
	["CETILE4B"]="stone",
	["CETILC4"]="stone",
	["CETILC4B"]="stone",
	["CEBUSTC1"]="stone",
	["CESTOND3"]="stone",
	["ACZWAL2"]="stone",
	["AC2_8_2_"]="stone",
	["ACDEBRIS"]="metal",
	["ACDEBRI2"]="metal",
	["ACMTRKF1"]="wood",
	["ACROAD1"]="stone",
	["ACSBCAN1"]="stone",
	["ACSBCAN3"]="stone",
	["ACSBDSRC"]="dirt",
	["ACSBDSRR"]="wood",
	["ACSBDSRT"]="dirt",
	["ACSTEAM0"]="metal",
	["ACROCKY1"]="stone",
	["ACROCKY2"]="stone",
	["ACROCKY3"]="stone",
	["ACROCKY4"]="stone",
	["ACROCKY5"]="stone",
	["ACROPE1"]="dirt",
	["ACROPE2"]="dirt",
	["ACROPF1"]="stone",
	["ACROPF2"]="stone",
	["ACROPF3"]="stone",
	["ACROPF4"]="stone",
	["ACZBARLF"]="metal",
	["ACZCRATF"]="wood",
	["ACZFLR01"]="stone",
	["ACZFLR02"]="stone",
	["ACZFLR03"]="stone",
	["ACZFLR04"]="wood",
	["ACZFLR05"]="wood",
	["ACZFLR06"]="wood",
	["ACZFLR07"]="wood",
	["ACZFLR08"]="wood",
	["ACZFLR09"]="wood",
	["ACZFLR10"]="wood",
	["ACZFLR11"]="wood",
	["ACZFLR12"]="metal",
	["ACZFLR13"]="metal",
	["ACZFLR14"]="cloth",
	["ACZFLR15"]="cloth",
	["ACZFLR16"]="wood",
	["ACZFLR17"]="wood",
	["ACZFLR18"]="wood",
	["ACZFLR19"]="wood",
	["ACZFLR20"]="stone",
	["ACZFLR21"]="stone",
	["ACZFLR22"]="cloth",
	["ACZFLR23"]="cloth",
	["ACZFLR24"]="stone",
	["ACZFLR25"]="stone",
	["ACZFLR26"]="stone",
	["ACZFLR27"]="stone",
	["ACZFLR28"]="stone",
	["ACZRAILF"]="metal",
	["ACZRAILP"]="stone",
	["ACZRFL1A"]="stone",
	["ACZRFL1B"]="stone",
	["ACZRFL1C"]="stone",
	["ACZRFL1D"]="stone",
	["ACZRFL1E"]="stone",
	["ACZRFL1F"]="stone",
	["ACZRFL1G"]="stone",
	["ACZRFL1H"]="stone",
	["ACZRFL2A"]="stone",	
	["ACZRFL2B"]="stone",
	["ACZRFL2C"]="stone",
	["ACZRFL2D"]="stone",
	["ACZRFL2E"]="stone",
	["ACZRFL2F"]="stone",
	["ACZRFL2G"]="stone",
	["ACZRFL2H"]="stone",	
	["ACZROKF1"]="stone",
	["ACZROKF2"]="stone",
	["ACZROCK3"]="stone",
	["ACWOODS1"]="wood",
	["ACWOODS2"]="wood",
	["ACWOOD1F"]="wood",
	["ACWOOD2F"]="wood",
	["ACWOOD3F"]="wood",
	["ACWOOD4F"]="wood",
	["ACWOODBX"]="wood",
	["FACSB_3"]="dirt",
	["FACSB_4"]="grass",
	["RVZWALF1"]="stone",
	["RVZWALF2"]="stone",
	["RVZWALF3"]="stone",
	["RVZWALF4"]="stone",
	["RVZWALF5"]="stone",
	["RVZWALF6"]="stone",
	["RVZWALF7"]="stone",
	["MMFLR7"]="stone",
	["MMFLR8"]="stone",
	["MMFLR9"]="stone",
	["MMFLRA"]="stone",
	["MMFLRB2"]="stone",
	["MMFLRB3"]="stone",
	["MMFLRB4"]="stone",
	["MMFLRB5"]="stone",
	["MMFLRB5A"]="stone",
	["MMFLRB6"]="stone",
	["MMFLRB7"]="stone",
	["MMFLRB8"]="stone",
	["MMFLRD"]="stone",
	["MMFLRE"]="stone",
	["MMFLRF"]="stone",
	["FLOOR6_2"]="stone",
	["MINECRAT"]="stone",
	["TLITE6_1"]="stone",
	["TLITE6_5"]="stone",
	["TLITE6_6"]="stone",
	["RVZDRUMT"]="stone",
	["RVZGRS01"]="grass",
	["RVZGRS02"]="grass",
	["RVZGRS03"]="grass",
	["RVZGRS04"]="grass",
	["RVZGRS05"]="grass",
	["RVZGRS06"]="grass",
	["RVZGRS07"]="grass",
	["RVZ2STOP"]="stone",
	["RVZ2SBTM"]="stone",
	["RVZ1SBTM"]="stone",
	["FRSTRCKF"]="stone",
	["MMBFLR9"]="stone",
	["MMBFLRA"]="stone",
	["MMBFLRB"]="stone",
	["MMBFLRC"]="stone",
	["RVDARKF1"]="stone",
	["RVDARKF2"]="stone",
	["RVPUMICF"]="stone",
	["RVRCKTTO"]="stone",
	["RVZ1S_BF"]="lava",
	["ERZBGF3"]="metal",
	["EGRIDF1"]="metal",
	["EGRIDF2"]="metal",
	["EGRIDF3"]="metal",
	["ERZBGF2"]="metal",
	["ERZBGF5"]="metal",
	["ERZBGF6"]="metal",
	["ERZBLUF2"]="metal",
	["ERZBLUF3"]="metal",
	["ERZBLUF4"]="metal",
	["ERZFAN1"]="metal",
	["ERZFAN2"]="metal",
	["ERZFAN3"]="metal",
	["ERZFAN4"]="metal",
	["ERZFANR1"]="metal",
	["ERZFANR2"]="metal",
	["ERZFANR3"]="metal",
	["ERZFANR4"]="metal",
	["ERZFLR00"]="metal",
	["ERZFLR01"]="metal",
	["ERZFLR02"]="metal",
	["ERZFLR03"]="metal",
	["ERZFLR04"]="metal",
	["ERZFLR05"]="metal",
	["ERZFLR06"]="metal",
	["ERZFLR07"]="metal",
	["ERZFLR08"]="metal",
	["ERZFLR09"]="metal",
	["ERZFLR10"]="metal",
	["ERZFLR11"]="metal",
	["ERZGREYF"]="metal",
	["ERZGRYF2"]="metal",
	["ERZGRYF3"]="metal",
	["ERZGRYF4"]="metal",
	["ERZMASH1"]="metal",
	["ERZMASH2"]="metal",
	["ERZMASH3"]="metal",
	["ERZMASH4"]="metal",
	["ERZMASH5"]="metal",
	["ERZMASH6"]="metal",
	["ERZMASH7"]="metal",
	["ERZMASH8"]="metal",
	["ERZPLTF1"]="metal",
	["ERZPLTF2"]="metal",
	["ERZPLTF3"]="metal",
	["ERZPLTF4"]="metal",
	["ERZPLTF5"]="metal",
	["ERZPLTF6"]="metal",
	["ERZRCKF1"]="stone",
	["ERZRCKF2"]="stone",
	["ERZRCKF3"]="stone",
	["ERZRCKF4"]="stone",
	["ERZRCKF5"]="stone",
	["ERZRCKF6"]="dirt",
	["ERZRCKF7"]="stone",
	["ERZRCKF8"]="stone",
	["ERZRCKF9"]="stone",
	["ERZREDF2"]="metal",
	["ERZREDF3"]="metal",
	["ERZREDF4"]="metal",
	["ERZREDF5"]="metal",
	["ERFANFL1"]="metal",
	["ERFANFL2"]="metal",
	["ERFANFL3"]="metal",
	["ERLAVA1"]="lava", 
	["ERZFLR13"]="metal",
	["ERZFLR14"]="metal",
	["ERZRCKF7"]="dirt",
	["ERZAI200"]="stone",
	["ERZAI201"]="stone",
	["ERZAI202"]="stone",
	["ERZAI203"]="stone",
	["ERZAI204"]="stone",
	["ERZAI205"]="stone",
	["ERZAI206"]="stone",
	["ERZAI207"]="stone",
	["ERZAI208"]="stone",
	["ERZAI209"]="stone",
	["ERZAI210"]="stone",
	["ERZAI211"]="stone",
	["ERZAI212"]="stone",
	["ERZAI213"]="stone",
	["ERZAI214"]="stone",
	["ERZAI215"]="stone",
	["ERZAIR00"]="stone",
	["ERZAIR01"]="stone",
	["ERZAIR02"]="stone",
	["ERZAIR03"]="stone",
	["ERZAIR04"]="stone",
	["ERZAIR05"]="stone",
	["ERZAIR06"]="stone",
	["ERZAIR07"]="stone",
	["ERZAIR08"]="stone",
	["ERZAIR09"]="stone",
	["ERZAIR10"]="stone",
	["ERZAIR11"]="stone",
	["ERZAIR12"]="stone",
	["ERZAIR13"]="stone",
	["ERZAIR14"]="stone",
	["ERZAIR15"]="stone",
	["ERZBGF1"]="metal",
	["ERZBGF4"]="metal",
	["ERZBLUF1"]="metal",
	["ERZBLUF5"]="metal",
	["ERZCRTF1"]="metal",
	["ERZFLR12"]="metal",
	["ERZGRYF1"]="metal",
	["ERZLITF2"]="metal",
	["ERZPI2F1"]="metal",
	["ERZPIPF1"]="metal",
	["ERZPIPF2"]="metal",
	["ERZPIPF5"]="metal",
	["ERZPIPF6"]="metal",
	["ERZPIPF8"]="metal",
	["ERZREDF1"]="metal",
	["ERZPIPF3"]="metal",
	["ERZPIPF9"]="metal",
	["ERZGRYF5"]="metal",
	["ERZGRTF1"]="metal",
	["ERZWRNF1"]="metal",
	["DCZFLR01"]="stone",
	["DCZFLR02"]="metal",
	["DCZFLR03"]="stone",
	["DCZFLR04"]="stone",
	["DCZFLR05"]="stone",
	["DCZFLR06"]="stone",
	["DCZFLR07"]="metal",
	["DCZFLR08"]="metal",
	["DCZFLR09"]="stone",
	["DCZFLR10"]="sand",
	["DCZFLR11"]="metal",
	["DCZFLR12"]="metal",
	["DCZFLR13"]="stone",
	["DCZFLR14"]="stone",
	["DCZFLR15"]="stone",
	["DCZFLR16"]="stone",
	["DCZFLR17"]="stone",
	["DCFLR01"]="stone",
	["DCFLR02"]="stone",
	["DCFLR03"]="stone",
	["DCFLR04"]="stone",
	["DCFLR05"]="stone",
	["DCFLR06"]="stone",
	["DCFLR07"]="stone",
	["DCFLR08"]="stone",
	["DCFLR09"]="stone",
	["DCFLR10"]="stone",
	["DCFLR11"]="stone",
	["DCFLR12"]="stone",
	["DCFLR13"]="stone",
	["DCFLR14"]="stone",
	["DCFLR15"]="stone",
	["DCFLR16"]="stone",
	["DCFLR17"]="stone",
	["DCFLR18"]="stone",
	["DCFLR19"]="stone",
	["DCFLR20"]="stone",
	["DCFLR21"]="stone",
	["DCFLR22"]="stone",
	["DCFLR23"]="stone",
	["DCFLR24"]="stone",
	["DCFLR25"]="stone",
	["DCZGRASS"]="grass",
	["DSHIPF1"]="metal",
	["DSHIPF2"]="metal",
	["DSHIPF3"]="metal",
	["DSHIPF4"]="metal",
	["DSHIPF5"]="metal",
	["DSHIPF6"]="metal",
	["DSHIPF7"]="metal",
	["DSHIPF8"]="metal",
	["DSHIPF9"]="metal",
	["DSHIPFA"]="metal",
	["DSHIPFB"]="metal",
	["DSHIPFC"]="metal",
	["DSHIPFD"]="metal",
	["DSHIPFE"]="metal",
	["LFLRA1"]="stone",
	["LFLRA2"]="stone",
	["LFLRA3"]="stone",
	["LFLRB1"]="stone",
	["LFLRB2"]="stone",
	["LFLRB3"]="stone",
	["LFLRB4"]="stone",
	["LFLRC1"]="stone",
	["LFLRC2"]="stone",
	["LFLRC3"]="stone",
	["LFLRC4"]="stone",
	["LFLRD1"]="stone",
	["LFLRD2"]="stone",	
	["LFLRE1"]="stone",
	["LFLRE2"]="stone",
	["LFLRF1"]="stone",
	["LFLRF1B"]="stone",
	["LFLRF2"]="stone",
	["LFLRF2B"]="stone",
	["LFLRF3"]="stone",
	["LFLRF4"]="stone",
	["GHZBRDG1"]="wood",
	["GHZBRDG2"]="wood",
	["GHZBRDG3"]="wood",
	["GHZBRDG4"]="wood",
	["GHZFLR02"]="wood",
	["GHZFLR07"]="stone",
	["GHZFLR08"]="stone",
	["GHZFLR09"]="wood",
	["GHZFLR0C"]="stone",
	["GHZROCKF"]="stone",
	["GRNLITE1"]="stone",
	["GATE2"]="stone",
	["2FORTF1"]="wood",
	["2FORTF2"]="wood",
	["2FORTF3"]="wood",
	["2FORTF4"]="wood",
	["2FORTF5"]="wood",
	["2FORTF6"]="wood",
	["2FORTF7"]="wood",
	["2FORTF8"]="wood",
	["2FORTF9"]="wood",
	["2FORTFA"]="wood",
	["2FORTFB"]="stone",
	["2FORTFC"]="stone",
	["WHITEFLR"]="stone",
	["LIMEFLR"]="stone",
	["BLUEFLR"]="stone",
	["CYANFLR"]="stone",
	["GREENFLR"]="stone",
	["GREYFLR"]="stone",
	["GOLDFLR"]="stone",
	["NEOGFLR"]="stone",
	["ORGFLR"]="stone",
	["VIOFLR"]="stone",
	["PURFLR"]="stone",
	["REDFLR"]="stone",
	["YELFLR"]="stone",
	["STLBLKF1"]="metal",
	["STLBLKF2"]="metal",
	["STLFLR01"]="metal",
	["STLFLR02"]="metal",
	["HPZBLOK"]="stone",
	["HPZROCK"]="stone",
	["GSPECF"]="stone",
	["GSPECF2"]="stone",
	["GSPECF3"]="stone",
	["PSPECF"]="stone",
	["PSPECF2"]="stone",
	["PSPECF3"]="stone",
	["BSPECF"]="stone",
	["BSPECF2"]="stone",
	["BSPECF3"]="stone",
	["CSPECF"]="stone",
	["CSPECF2"]="stone",
	["CSPECF3"]="stone",
	["YSPECF"]="stone",
	["YSPECF2"]="stone",
	["YSPECF3"]="stone",
	["RSPECF"]="stone",
	["RSPECF2"]="stone",
	["RSPECF3"]="stone",
	["ASPECF"]="stone",
	["ASPECF2"]="stone",
	["ASPECF3"]="stone",
	["SFLR01"]="stone",
	["SFLR01B"]="stone",
	["SFLR02"]="stone",
	["SFLR02B"]="stone",
	["SFLR03"]="stone",
	["SFLR04"]="stone",
	["SFLR05"]="stone",
	["SFLR06"]="stone",
	["SFLR07"]="stone",
	["SFLR08"]="stone",
	["SFLR09"]="stone",
	["SFLR10"]="stone",
	["SFLR11"]="stone",
	["SFLR12"]="stone",
	["SFLR13"]="stone",
	["SFLR14"]="stone",
	["SFLR15"]="stone",
	["SFLR16"]="stone",
	["SFLR17"]="stone",
	["SFLR18"]="stone",
	["SFLR19"]="stone",
	["SFLR20"]="stone",
	["SFLR21"]="stone",
	["SFLR22"]="stone",
	["SFLR23"]="stone",
	["SFLR24"]="stone",
	["SFLR25"]="stone",
	["SFLR26"]="stone",
	["SFLR27"]="stone",
	["SFLR28"]="stone",
	["SFLR29"]="stone",
	["SFLR30"]="stone",
	["SFLR31"]="stone",
	["SFLR32"]="stone",
	["SFLR33"]="stone",
	["SFLR34"]="stone",
	["SFLR35"]="stone",
	["SPACEBL"]="stone",
	["SPACEBM"]="stone",
	["SPACEBS"]="stone",
	["SPACEGL"]="stone",
	["SPACEGM"]="stone",
	["SPACEGS"]="stone",
	["SPACERL"]="stone",
	["SPACERM"]="stone",
	["SPACERS"]="stone",
	["DSBLOCB1"]="stone",
	["GFZFWR01"]="grass",
	["GFZFWR02"]="grass",
	["THPIPEFA"]="stone",
	["THPIPEFB"]="stone",
	["THPIPEFC"]="stone",
	["THPIPEFD"]="stone",
	["BWATER01"]="water",
	["BWATER02"]="water",
	["BWATER03"]="water",
	["BWATER04"]="water",
	["BWATER05"]="water",
	["BWATER06"]="water",
	["BWATER07"]="water",
	["BWATER08"]="water",
	["BWATER09"]="water",
	["BWATER10"]="water",
	["BWATER11"]="water",
	["BWATER12"]="water",
	["BWATER13"]="water",
	["BWATER14"]="water",
	["BWATER15"]="water",
	["BWATER16"]="water",
	["FWATER1"]="water",
	["FWATER2"]="water",
	["FWATER3"]="water",
	["FWATER4"]="water",
	["FWATER5"]="water",
	["FWATER6"]="water",
	["FWATER7"]="water",
	["FWATER8"]="water",
	["FWATER9"]="water",
	["FWATER10"]="water",
	["FWATER11"]="water",
	["FWATER12"]="water",
	["FWATER13"]="water",
	["FWATER14"]="water",
	["FWATER15"]="water",
	["FWATER16"]="water",
	["CHEMG01"]="water",
	["CHEMG02"]="water",
	["CHEMG03"]="water",
	["CHEMG04"]="water",
	["CHEMG05"]="water",
	["CHEMG06"]="water",
	["CHEMG07"]="water",
	["CHEMG08"]="water",
	["CHEMG09"]="water",
	["CHEMG10"]="water",
	["CHEMG11"]="water",
	["CHEMG12"]="water",
	["CHEMG13"]="water",
	["CHEMG14"]="water",
	["CHEMG15"]="water",
	["CHEMG16"]="water",
	["GWATER01"]="water",
	["GWATER02"]="water",
	["GWATER03"]="water",
	["GWATER04"]="water",
	["GWATER05"]="water",
	["GWATER06"]="water",
	["GWATER07"]="water",
	["GWATER08"]="water",
	["GWATER09"]="water",
	["GWATER10"]="water",
	["GWATER11"]="water",
	["GWATER12"]="water",
	["GWATER13"]="water",
	["GWATER14"]="water",
	["GWATER15"]="water",
	["GWATER16"]="water",
	["GOOP01"]="water",
	["GOOP02"]="water",
	["GOOP03"]="water",
	["GOOP04"]="water",
	["GOOP05"]="water",
	["GOOP06"]="water",
	["GOOP07"]="water",
	["GOOP08"]="water",
	["GOOP09"]="water",
	["GOOP10"]="water",
	["GOOP11"]="water",
	["GOOP12"]="water",
	["GOOP13"]="water",
	["GOOP14"]="water",
	["GOOP15"]="water",
	["GOOP16"]="water",
	["LWATER1"]="water",
	["LWATER2"]="water",
	["LWATER3"]="water",
	["LWATER4"]="water",
	["LWATER5"]="water",
	["LWATER6"]="water",
	["LWATER7"]="water",
	["LWATER8"]="water",
	["LWATER9"]="water",
	["LWATER10"]="water",
	["LWATER11"]="water",
	["LWATER12"]="water",
	["LWATER13"]="water",
	["LWATER14"]="water",
	["LWATER15"]="water",
	["LWATER16"]="water",
	["TAR"]="lava",
	["OIL01"]="water",
	["OIL02"]="water",
	["OIL03"]="water",
	["OIL04"]="water",
	["OIL05"]="water",
	["OIL06"]="water",
	["OIL07"]="water",
	["OIL08"]="water",
	["OIL09"]="water",
	["OIL10"]="water",
	["OIL11"]="water",
	["OIL12"]="water",
	["OIL13"]="water",
	["OIL14"]="water",
	["OIL15"]="water",
	["OIL16"]="water",
	["LAVA1"]="lava",
	["LAVA2"]="lava",
	["LAVA3"]="lava",
	["LAVA4"]="lava",
	["RLAVA1"]="lava",
	["RLAVA2"]="lava",
	["RLAVA3"]="lava",
	["RLAVA4"]="lava",
	["RLAVA5"]="lava",
	["RLAVA6"]="lava",
	["RLAVA7"]="lava",
	["RLAVA8"]="lava",
	["SURF01"]="water",
	["SURF02"]="water",
	["SURF03"]="water",
	["SURF04"]="water",
	["SURF05"]="water",
	["SURF06"]="water",
	["SURF07"]="water",
	["SURF08"]="water",
	["WATER0"]="water",
	["WATER1"]="water",
	["WATER2"]="water",
	["WATER3"]="water",
	["WATER4"]="water",
	["WATER5"]="water",
	["WATER6"]="water",
	["WATER7"]="water",
	["SICK01"]="water",
	["SICK02"]="water",
	["SICK03"]="water",
	["SICK04"]="water",
	["SICK05"]="water",
	["SICK06"]="water",
	["SICK07"]="water",
	["SICK08"]="water",
	["SICK09"]="water",
	["SICK10"]="water",
	["SICK11"]="water",
	["SICK12"]="water",
	["SICK13"]="water",
	["SICK14"]="water",
	["SICK15"]="water",
	["SICK16"]="water",
	["HHWATR01"]="water",
	["HHWATR02"]="water",
	["HHWATR03"]="water",
	["HHWATR04"]="water",
	["HHWATR05"]="water",
	["HHWATR06"]="water",
	["HHWATR07"]="water",
	["HHWATR08"]="water",
	["HHWATR09"]="water",
	["HHWATR10"]="water",
	["HHWATR11"]="water",
	["HHWATR12"]="water",
	["HHWATR13"]="water",
	["HHWATR14"]="water",
	["HHWATR15"]="water",
	["HHWATR16"]="water",
	["CLIFF1"]="stone",
	["CLIFF2"]="stone",
	["CLIFF3"]="stone",
	["CLIFF4"]="stone",
	["CLIFF5"]="stone",
	["CLIFF6"]="stone",
	["CLIFF7"]="stone",
	["CLIFF8"]="stone",
	["CLIFF9"]="stone",
	["CLIFFA"]="stone",
	["CLIFFB"]="stone",
	["CLIFFC"]="stone",
	["CLIFFD"]="stone",
	["CLIFF1S"]="stone",
	["CLIFF2S"]="stone",
	["CLIFF3S"]="stone",
	["CLIFF4S"]="stone",
	["CLIFF5S"]="stone",
	["CLIFF6S"]="stone",
	["CLIFF7S"]="stone",
	["CLIFF8S"]="stone",
	["CLIFF9S"]="stone",
	["CLIFFAS"]="stone",
	["CLIFFBS"]="stone",
	["CLIFFCS"]="stone",
	["CLIFFDS"]="stone",
	["CLIFFE"]="stone",
	["CLIFFES"]="stone",
	["CLIFFF"]="stone",
	["CLIFFFS"]="stone",
	["CLIFFG"]="stone",
	["CLIFFGS"]="stone",
	["CLIFFH"]="stone",
	["CLIFFHS"]="stone",
	["JNGF13S"]="stone",
	["JNGF14S"]="stone",
	["JNGF15S"]="stone",
	["JNGF16S"]="stone",
	["JNGFLR01"]="stone",
	["JNGFLR02"]="stone",
	["JNGFLR03"]="stone",
	["JNGFLR04"]="stone",
	["JNGFLR05"]="wood",
	["JNGFLR06"]="wood",
	["JNGFLR07"]="wood",
	["JNGFLR08"]="wood",
	["JNGFLR09"]="grass",
	["JNGFLR10"]="grass",
	["JNGFLR11"]="grass",
	["JNGFLR12"]="grass",
	["JNGFLR13"]="stone",
	["JNGFLR14"]="stone",
	["JNGFLR15"]="stone",
	["JNGFLR16"]="stone",
	["JNGGRS01"]="grass",
	["JNGGRS02"]="grass",
	["JNGGRS03"]="grass",
	["JNGGRS04"]="grass",
	["JNGGRS05"]="grass",
	["JNGGRS06"]="grass",
	["JNGGRS07"]="grass",
	["JNGGRS08"]="grass",
	["JNGGRS09"]="grass",
	["JNGGRS10"]="grass",
	["JNGGRS11"]="grass",
	["JNGGRS12"]="grass",
	["JNGMUDF1"]="dirt",
	["JNGMUDF2"]="dirt",
	["JNGMUDF3"]="dirt",
	["JNGMUDF4"]="dirt",
	["JNGMUDF5"]="dirt",
	["JNGRCKF1"]="stone",
	["JNGRCKF2"]="stone",
	["JNGRCKF3"]="stone",
	["JNGRCKF4"]="stone",
	["JNGWDF1"]="wood",
	["JNGWDF1B"]="wood",
	["JNGWDF1S"]="wood",
	["JNGWDF2"]="wood",
	["JNGWDF2B"]="wood",
	["JNGWDF2S"]="wood",
	["JNGWDF3"]="wood",
	["JNGWDF3B"]="wood",
	["JNGWDF3S"]="wood",
	["JNGWDF4"]="wood",
	["JNGWDF4B"]="wood",
	["JNGWDF4S"]="wood",
	["JNGWDF5"]="wood",
	["JNGWDF6"]="wood",
	["JNGWDF7"]="wood",
	["JNGWDF8"]="wood",
	["JNGWDF9"]="wood",
	["JNGWDFA"]="wood",
	["JNGWDFB"]="wood",
	["JNGWDFC"]="wood",
	["CAVEF1"]="stone",
	["CAVEF2"]="stone",
	["CAVEF3"]="stone",
	["CAVEF4"]="stone",
	["CAVEF5"]="stone",
	["CAVEF6"]="stone",
	["CAVEF7"]="stone",
	["CAVEF8"]="stone",
	["CAVEF9"]="stone",
	["CAVEFA"]="stone",
	["CAVEFB"]="stone",
	["XMSFLR01"]="stone",
	["XMSFLR02"]="snow",
	["XMSFLR03"]="stone",
	["XMSFLR04"]="stone",
	["XMSFLR05"]="wood",
	["XMSFLR06"]="wood",
	["XMSFLR07"]="stone",
	["XMSFLR08"]="wood",
	["XMSFLR09"]="wood",
	["XMSFLR10"]="wood",
	["XMSFLR11"]="wood",
	["XMSFLR12"]="wood",
	["XMSFLR13"]="wood",
	["XMSFLR14"]="wood",
	["XMSFLR15"]="stone",
	["XMSFLR16"]="wood",
	["XMSFLR17"]="stone",
	["XMSFLR18"]="stone",
	["XMSFLR19"]="stone",
	["XMSFLR20"]="stone",
	["FHZICEFL"]="stone",
	["FGZROKFL"]="stone",
	["APFLOR1"]="metal",
	["APFLOR2"]="metal",
	["APFLOR3"]="metal",
	["APFLOR4"]="metal",
	["APFLOR5"]="metal",
	["APFLOR6"]="metal",
	["APFLOR7"]="metal",
	["ICEFLR0"]="stone",
	["ICEFLR1"]="stone",
	["ICEFLR2"]="stone",
	["ICEFLR3"]="stone",
	["ICEFLR3S"]="stone",
	["ICEFLR4"]="stone",
	["ICEFLR4S"]="stone",
	["ICEFLR5"]="stone",
	["ICEFLR6"]="stone",
	["ICEFLR7"]="stone",
	["ICEFLR8"]="stone",
	["ICEFLR9"]="glass",
	["ICEFLR9S"]="glass",
	["ICEFLRA"]="glass",
	["SNOW01"]="snow",
	["SNOW02"]="snow",
	["SNOW03"]="snow",
	["LAKEFLR1"]="dirt",
	["LAKEFLR2"]="sand",
	["LAKEFLR3"]="sand",
	["LAKEFLR4"]="grass",
	["LAKEFLR5"]="stone",
	["LAKEFLR6"]="stone",
	["LAKEFLR7"]="stone",
	["LAKEFLRD"]="stone",
	["LAKEFLRE"]="stone",
	["LAKEPIF1"]="metal",
	["LAKEPIF2"]="metal",
	["LAKEFLRF"]="stone",
	["SRB1FE1"]="stone",
	["SRB1FIP1"]="stone",
	["SRB1FKB1"]="stone",
	["SRB1FR1"]="metal",
	["SRB1FRB1"]="metal",
	["SRB1FV1"]="stone",
	["SRB1FV2"]="stone",
	["SRB1FV3"]="stone",
	["HPFLOOR%20"]="stone",
	["HPEMERAL"]="stone",
	["MHFL1"]="dirt",
	["MHFL2A"]="grass",
	["MHFL2B"]="grass",
	["MHFL3"]="dirt",
	["MHFL4"]="dirt",
	["LBZFLORC"]="stone",
	["LBZFLOR7"]="stone",
	["LBZFLOR8"]="stone",
	["LBZFLOR9"]="stone",
	["LBZFLORA"]="stone",
	["LBZFLORB"]="stone",
	["LBZFLR07"]="metal",
	["LBZFLR08"]="metal",
	["LBZFLR09"]="metal",
	["SCBBLKF1"]="metal",
	["SCBFLR01"]="metal",
	["SCBFLR02"]="metal",
	["SCBFLR03"]="metal",
	["SCBFLR04"]="metal",
	["NIZF01"]="stone",
	["HHZGRAS1"]="grass",
	["HHZGRAS2"]="grass",
	["HHZF1"]="metal",
	["BSFLR1"]="metal",
	["BSFLR1B"]="metal",
	["BSFLR1C"]="metal",
	["BSFLR1D"]="metal",
	["BSFLR1DB"]="metal",
	["BSFLR1E"]="metal",
	["BSFLR1F"]="metal",
	["BSFLR2"]="metal",
	["BSFLR2B"]="metal",
	["BSFLR2C"]="metal",
	["BSFLR2D"]="metal",
	["BSFLR2DB"]="metal",
	["BSFLR2E"]="metal",
	["BSFLR2F"]="metal",
	["BSFLR3"]="metal",
	["BSFLR3B"]="metal",
	["BSFLR3C"]="metal",
	["BSFLR3D"]="metal",
	["BSFLR3DB"]="metal",
	["BSFLR3E"]="metal",
	["BSFLR3F"]="metal",
	["BSFLR4"]="metal",
	["BSFLR4E"]="metal",
	["BSFLR5"]="metal",
	["BSFLR5B"]="metal",
	["BSFLR5C"]="metal",
	["BSFLR5D"]="metal",
	["BSFLR5DB"]="metal",
	["BSFLR5E"]="metal",
	["BSFLR5F"]="metal",
	["BSFLR6"]="metal",
	["BSFLR6B"]="metal",
	["BSFLR6C"]="metal",
	["BSFLR6D"]="metal",
	["BSFLR6DB"]="metal",
	["BSFLR6E"]="metal",
	["BSFLR6F"]="metal",
	["SCBGRATE"]="metal",
	["HHZCRACF"]="stone",
	["HHZSTNF1"]="stone",
	["HHZSTNF2"]="stone",
	["WEBBIGF"]="grass",
	["WEBBIGF2"]="grass",
	["WEBBIGF3"]="grass",
	["CONCBLAK"]="stone",
	["CONVEY1"]="metal",
	["CONVEY2"]="metal",
	["TOMBNTOP"]="stone",
	["HHZBLAC2"]="stone",
	["HHZBLACK"]="stone",
	["~000"]="stone",
	["~001"]="stone",
	["~002"]="stone",
	["~003"]="stone",
	["~004"]="stone",
	["~005"]="stone",
	["~006"]="stone",
	["~007"]="stone",
	["~008"]="stone",
	["~009"]="stone",
	["~010"]="stone",
	["~011"]="stone",
	["~012"]="stone",
	["~013"]="stone",
	["~014"]="stone",
	["~015"]="stone",
	["~016"]="stone",
	["~017"]="stone",
	["~018"]="stone",
	["~019"]="stone",
	["~020"]="stone",
	["~021"]="stone",
	["~022"]="stone",
	["~023"]="stone",
	["~024"]="stone",
	["~025"]="stone",
	["~026"]="stone",
	["~027"]="stone",
	["~028"]="stone",
	["~029"]="stone",
	["~030"]="stone",
	["~031"]="stone",
	["~032"]="stone",
	["~033"]="stone",
	["~034"]="stone",
	["~035"]="stone",
	["~036"]="stone",
	["~037"]="stone",
	["~038"]="stone",
	["~039"]="stone",
	["~040"]="stone",
	["~041"]="stone",
	["~042"]="stone",
	["~043"]="stone",
	["~044"]="stone",
	["~045"]="stone",
	["~046"]="stone",
	["~047"]="stone",
	["~048"]="stone",
	["~049"]="stone",
	["~050"]="stone",
	["~051"]="stone",
	["~052"]="stone",
	["~053"]="stone",
	["~054"]="stone",
	["~055"]="stone",
	["~056"]="stone",
	["~057"]="stone",
	["~058"]="stone",
	["~059"]="stone",
	["~060"]="stone",
	["~061"]="stone",
	["~062"]="stone",
	["~063"]="stone",
	["~064"]="stone",
	["~065"]="stone",
	["~066"]="stone",
	["~067"]="stone",
	["~068"]="stone",
	["~069"]="stone",
	["~070"]="stone",
	["~071"]="stone",
	["~072"]="stone",
	["~073"]="stone",
	["~074"]="stone",
	["~075"]="stone",
	["~076"]="stone",
	["~077"]="stone",
	["~078"]="stone",
	["~079"]="stone",
	["~080"]="stone",
	["~081"]="stone",
	["~082"]="stone",
	["~083"]="stone",
	["~084"]="stone",
	["~085"]="stone",
	["~086"]="stone",
	["~087"]="stone",
	["~088"]="stone",
	["~089"]="stone",
	["~090"]="stone",
	["~091"]="stone",
	["~092"]="stone",
	["~093"]="stone",
	["~094"]="stone",
	["~095"]="stone",
	["~096"]="stone",
	["~097"]="stone",
	["~098"]="stone",
	["~099"]="stone",
	["~100"]="stone",
	["~101"]="stone",
	["~102"]="stone",
	["~103"]="stone",
	["~104"]="stone",
	["~105"]="stone",
	["~106"]="stone",
	["~107"]="stone",
	["~108"]="stone",
	["~109"]="stone",
	["~110"]="stone",
	["~111"]="stone",
	["~112"]="stone",
	["~113"]="stone",
	["~114"]="stone",
	["~115"]="stone",
	["~116"]="stone",
	["~117"]="stone",
	["~118"]="stone",
	["~119"]="stone",
	["~120"]="stone",
	["~121"]="stone",
	["~122"]="stone",
	["~123"]="stone",
	["~124"]="stone",
	["~125"]="stone",
	["~126"]="stone",
	["~127"]="stone",
	["~128"]="stone",
	["~129"]="stone",
	["~130"]="stone",
	["~131"]="stone",
	["~132"]="stone",
	["~133"]="stone",
	["~134"]="stone",
	["~135"]="stone",
	["~136"]="stone",
	["~137"]="stone",
	["~138"]="stone",
	["~139"]="stone",
	["~140"]="stone",
	["~141"]="stone",
	["~142"]="stone",
	["~143"]="stone",
	["~144"]="stone",
	["~145"]="stone",
	["~146"]="stone",
	["~147"]="stone",
	["~148"]="stone",
	["~149"]="stone",
	["~150"]="stone",
	["~151"]="stone",
	["~152"]="stone",
	["~153"]="stone",
	["~154"]="stone",
	["~155"]="stone",
	["~156"]="stone",
	["~157"]="stone",
	["~158"]="stone",
	["~159"]="stone",
	["~160"]="stone",
	["~161"]="stone",
	["~162"]="stone",
	["~163"]="stone",
	["~164"]="stone",
	["~165"]="stone",
	["~166"]="stone",
	["~167"]="stone",
	["~168"]="stone",
	["~169"]="stone",
	["~170"]="stone",
	["~171"]="stone",
	["~172"]="stone",
	["~173"]="stone",
	["~174"]="stone",
	["~175"]="stone",
	["~176"]="stone",
	["~177"]="stone",
	["~178"]="stone",
	["~179"]="stone",
	["~180"]="stone",
	["~181"]="stone",
	["~182"]="stone",
	["~183"]="stone",
	["~184"]="stone",
	["~185"]="stone",
	["~186"]="stone",
	["~187"]="stone",
	["~188"]="stone",
	["~189"]="stone",
	["~190"]="stone",
	["~191"]="stone",
	["~192"]="stone",
	["~193"]="stone",
	["~194"]="stone",
	["~195"]="stone",
	["~196"]="stone",
	["~197"]="stone",
	["~198"]="stone",
	["~199"]="stone",
	["~200"]="stone",
	["~201"]="stone",
	["~202"]="stone",
	["~203"]="stone",
	["~204"]="stone",
	["~205"]="stone",
	["~206"]="stone",
	["~207"]="stone",
	["~208"]="stone",
	["~209"]="stone",
	["~210"]="stone",
	["~211"]="stone",
	["~212"]="stone",
	["~213"]="stone",
	["~214"]="stone",
	["~215"]="stone",
	["~216"]="stone",
	["~217"]="stone",
	["~218"]="stone",
	["~219"]="stone",
	["~220"]="stone",
	["~221"]="stone",
	["~222"]="stone",
	["~223"]="stone",
	["~224"]="stone",
	["~225"]="stone",
	["~226"]="stone",
	["~227"]="stone",
	["~228"]="stone",
	["~229"]="stone",
	["~230"]="stone",
	["~231"]="stone",
	["~232"]="stone",
	["~233"]="stone",
	["~234"]="stone",
	["~235"]="stone",
	["~236"]="stone",
	["~237"]="stone",
	["~238"]="stone",
	["~239"]="stone",
	["~240"]="stone",
	["~241"]="stone",
	["~242"]="stone",
	["~243"]="stone",
	["~244"]="stone",
	["~245"]="stone",
	["~246"]="stone",
	["~247"]="stone",
	["~248"]="stone",
	["~249"]="stone",
	["~250"]="stone",
	["~251"]="stone",
	["~252"]="stone",
	["~253"]="stone",
	["~254"]="stone",
	["~255"]="stone",
	["BSZFLOOR"]="grass",
	["FLOWB_04"]="grass",
	["FLOWO_04"]="grass",
	["FLOWP_04"]="grass",
	["FLOWR_04"]="grass",
	["FLOWW_04"]="grass",
	["FLOWY_04"]="grass",
	["FWALL_04"]="grass",
	["FWB_04"]="grass",
	["FWBOW_04"]="grass",
	["FWBOY_04"]="grass",
	["FWBP_04"]="grass",
	["FWBPW_04"]="grass",
	["FWBPY_04"]="grass",
	["FWBWY_04"]="grass",
	["FWBY_04"]="grass",
	["FWO_04"]="grass",
	["FWOP_04"]="grass",
	["FWOPY_04"]="grass",
	["FWORY_04"]="grass",
	["FWOWY_04"]="grass",
	["FWP_04"]="grass",
	["FWPW_04"]="grass",
	["FWR_04"]="grass",
	["FWW_04"]="grass",
	["FWWY_04"]="grass",
	["FLBWY_02"]="grass",
	["FLOBY_02"]="grass",
	["FLBWY_R2"]="grass",
	["FWBWY_02"]="grass",
	["BSZGRASF"]="grass",
	["FLOWO_01"]="grass",
	["FLOWR_01"]="grass",
	["FLOWP_01"]="grass",
	["FLOWW_01"]="grass",
	["FLOWB_01"]="grass",
	["FLOWY_01"]="grass",
	["FLOWB_02"]="grass",
	["FLOWO_02"]="grass",
	["FLOWP_02"]="grass",
	["FLOWR_02"]="grass",
	["FLOWW_02"]="grass",
	["FLOWY_02"]="grass",
	["FLOWG_01"]="grass",
	["FLOWP_03"]="grass",
	["FLOWR_03"]="grass",
	["FLOWW_03"]="grass",
	["FLOWB_03"]="grass",
	["FLOWO_03"]="grass",
	["FLOWY_03"]="grass",
	["BSZFLR01"]="metal",
	["BSZFLR02"]="metal",
	["BSZFLR03"]="stone",
	["BSZFLR04"]="metal",
	["AGZFLR01"]="stone",
	["AGZFLR02"]="stone",
	["BLUINSID"]="stone",
	["BRICK1"]="stone",
	["BRICK2"]="stone",
	["BRICK3"]="stone",
	["BRICK4"]="stone",
	["BUSTFLR"]="stone",
	["CARPET01"]="cloth",
	["CARPET02"]="cloth",
	["CARPET03"]="cloth",
	["CARPET04"]="cloth",
	["CARPET05"]="cloth",
	["CARPET06"]="cloth",
	["CARPET07"]="cloth",
	["CARPET08"]="cloth",
	["CARPET09"]="cloth",
	["CARPET10"]="cloth",
	["CARPET11"]="cloth",
	["CARPET12"]="cloth",
	["CARPET13"]="cloth",
	["CARPET14"]="cloth",
	["CASINOF1"]="stone",
	["CASINOF2"]="stone",
	["CASINOF3"]="stone",
	["CASINOF4"]="stone",
	["CATFLR02"]="metal",
	["CATFLR03"]="metal",
	["CATFLR04"]="metal",
	["CEIL3_1"]="metal",
	["CEMENT2"]="stone",
	["CHEKSMOL"]="stone",
	["CHKGRASF"]="grass",
	["D2LAVA"]="stone",
	["DEM1_1"]="stone",
	["DEM1_2"]="grass",
	["DEM1_3"]="metal",
	["DEM1_5"]="sand",
	["DEM1_6"]="wood",
	["DEZBLKF1"]="metal",
	["DEZBLKF2"]="metal",
	["DEZBLKF3"]="metal",
	["DEZBLKF4"]="metal",
	["DEZBLKF5"]="metal",
	["DEZBLKF6"]="metal",
	["DEZBLKF7"]="metal",
	["DEZBLKF8"]="metal",
	["DEZBLOKF"]="metal",
	["DEZBRKF"]="metal",
	["DFZCLD1"]="stone",
	["DFZCLD2"]="stone",
	["DFZCLD3"]="stone",
	["DIRT"]="dirt",
	["DIRT1F"]="dirt",
	["DIRT2F"]="dirt",
	["DIRT3F"]="dirt",
	["DIRT4F"]="dirt",
	["DIRT5F"]="dirt",
	["DISCO1"]="glass",
	["DISCO2"]="glass",
	["DISCO3"]="glass",
	["DISCO4"]="glass",
	["DISCOF1"]="cloth",
	["DKLEAFLR"]="grass",
	["DLAVA1"]="stone",
	["DLAVA2"]="stone",
	["DLAVA3"]="stone",
	["DLAVA4"]="stone",
	["DMAPIPE"]="metal",
	["DMAPIPE2"]="metal",
	["DPFLAT1"]="stone",
	["DPFLAT2"]="stone",
	["DPPILL2F"]="stone",
	["DPPILLRF"]="stone",
	["DPSAND"]="sand",
	["DPSAND2"]="sand",
	["EC_VINES"]="grass",
	["EC_VINET"]="grass",
	["ERZBLCAU"]="metal",
	["ERZRDCAU"]="metal",
	["ERZYLCAU"]="metal",
	["FLAT1_2"]="metal",
	["FLOOR0_2"]="dirt",
	["FLOOR0_4"]="stone",
	["FLOOR1_2"]="wood",
	["FLOOR1_3"]="wood",
	["FLOOR6_1"]="stone",
	["FOSSIL"]="stone",
	["FROST01"]="stone",
	["FROST02"]="stone",
	["GEOBMP1"]="stone",
	["GEOBMP1S"]="stone",
	["GLASS3"]="glass",
	["GRASS1"]="grass",
	["GRASS2"]="grass",
	["GRASS3"]="grass",
	["GRASSY"]="grass",
	["HNYLEAFF"]="grass",
	["HONEYF"]="stone",
	["LFZFLR1"]="stone",
	["LFZFLR2"]="grass",
	["LFZFLR3"]="grass",
	["LFZFLR4"]="dirt",
	["LFZFLR5"]="dirt",
	["LIFTFLAT"]="metal",
	["LITEB1"]="metal",
	["LITEB2"]="metal",
	["LITEB3"]="metal",
	["LITEN1"]="metal",
	["LITEN2"]="metal",
	["LITEN3"]="metal",
	["LITER1"]="metal",
	["LITER2"]="metal",
	["LITER3"]="metal",
	["LITEY1"]="metal",
	["LITEY2"]="metal",
	["LITEY3"]="metal",
	["LVASAND1"]="stone",
	["LVASAND2"]="stone",
	["MEKPIPF1"]="metal",
	["MEKPIPF2"]="metal",
	["MEKPIPF3"]="metal",
	["MEKPIPF4"]="metal",
	["MEKPIPF5"]="metal",
	["MEKPIPF6"]="metal",
	["MEKPIPF7"]="metal",
	["MRNR1T1"]="stone",
	["MRNR1T2"]="stone",
	["MRNR2T1"]="stone",
	["MRNR2T2"]="stone",
	["MRNR3T1"]="stone",
	["MRNR3T2"]="stone",
	["MRNR4T1"]="stone",
	["MRNR4T2"]="stone",
	["PAZFLR01"]="glass",
	["PAZFLR02"]="glass",
	["PAZFLR03"]="glass",
	["PAZFLR04"]="glass",
	["PAZFLR05"]="stone",
	["PIT"]="stone",
	["QUIK2"]="sand",
	["QUIK3"]="sand",
	["QUIK4"]="sand",
	["QUIK5"]="sand",
	["QUIK6"]="sand",
	["QUIK7"]="sand",
	["QUIKNOAN"]="sand",
	["RAINBOW1"]="stone",
	["RAINBOW2"]="stone",
	["RAINBOW3"]="stone",
	["RAINBOW4"]="stone",
	["RCZCRSF1"]="stone",
	["RCZCRSF2"]="stone",
	["RCZCRSF3"]="stone",
	["RCZCRSF4"]="stone",
	["RCZFLR1"]="stone",
	["RCZFLR2"]="stone",
	["RCZFLR3"]="stone",
	["RCZFLR4"]="stone",
	["RCZFLR5"]="stone",
	["RCZFLR6"]="stone",
	["RCZFLR7"]="stone",
	["RCZFLR8"]="stone",
	["RECORD"]="stone",
	["ROCKBOIL"]="stone",
	["ROCKBOIM"]="stone",
	["ROCKF1"]="stone",
	["ROCKF2"]="stone",
	["ROCKF3"]="stone",
	["ROCKF4"]="stone",
	["ROCKF5"]="stone",
	["ROCKFLR1"]="stone",
	["ROCKFLR2"]="stone",
	["ROCKFLR3"]="stone",
	["ROCKFLR4"]="stone",
	["ROCKMF11"]="stone",
	["ROCKY1F"]="stone",
	["ROCKY2F"]="stone",
	["ROCKY3F"]="stone",
	["ROCKY4F"]="stone",
	["ROCKY5F"]="stone",
	["ROCKY6F"]="stone",
	["RUINS1_1"]="stone",
	["RUINS1_2"]="stone",
	["SAND"]="sand",
	["SANDFLR"]="sand",
	["SANDFLRA"]="stone",
	["SANDFLRB"]="stone",
	["SANDFLRC"]="stone",
	["SEGGF01"]="stone",
	["SEGGF02"]="stone",
	["SEGGF03"]="stone",
	["SEGGF04"]="stone",
	["SEGGF05"]="stone",
	["SFZLEAF"]="grass",
	["SHALEF1"]="stone",
	["SHALEF2"]="stone",
	["SHROOM1"]="dirt",
	["SHROOM2"]="dirt",
	["SHROOM3"]="dirt",
	["SKY1024"]="stone",
	["SKY1026"]="stone",
	["SKY1028"]="stone",
	["SNDPILRA"]="stone",
	["SPACEYL"]="stone",
	["SPACEYM"]="stone",
	["SPACEYS"]="stone",
	["STONE01"]="stone",
	["STONEF1"]="stone",
	["STONEF2"]="stone",
	["TRAPFLR"]="metal",
	["VENT1"]="metal",
	["VENT1F"]="metal",
	["VFZFLR01"]="grass",
	["WOODFLR"]="wood",
	["WOODFLR2"]="wood",
	["WOODFLR3"]="wood",
	["WOODFLR4"]="wood",
	["WSPECF"]="stone",
	["XTRMCHK"]="stone",
	["YLOPIPF1"]="stone",
	["YLOPIPF2"]="stone",
	["YLOPIPF3"]="stone",
	["YLOPIPF4"]="stone",
	["ZIMFLR01"]="stone",
	["ZIMTILE1"]="cloth",
	["ZIMTILE2"]="cloth",
	["ZIMTILE3"]="cloth",
	["ZIMTILE4"]="cloth",
	["WOODWALL"]="wood",
	["LEGFLR01"]="metal",
	["LEGFLR08"]="metal",
	["LEGFLR18"]="metal",
	["OLDCEZF3"]="grass",
	["D2SANDV"]="sand",
	["DSSANDV"]="sand",
	["SPAD01"]="metal",
	["SPAD02"]="metal",
	["SPAD03"]="metal",
	["SPAD04"]="metal",
	["SPADD01"]="metal",
	["SPADD02"]="metal",
	["SPADD03"]="metal",
	["SPADD04"]="metal",
	["BOX01"]="wood",
	["BOX02"]="metal",
	["BOX3"]="metal",
	["WAVE01"]="wood",
	["WAVE02"]="grass",
	["WAVE03"]="stone",
	["WAVE04"]="wood",
	["WAVE05"]="wood",
	["WAVE06"]="stone",
	["WAVE07"]="stone",
	["WAVE08"]="stone",
	["WAVE09"]="stone",
	["WAVE10"]="stone",
	["WAVE11"]="metal",
	["WAVE12"]="grass",
	["WAVE13"]="metal",
	["WAVE14"]="stone",
	["WAVE15"]="grass",
	["DUSTY01"]="sand",
	["DUSTY02"]="stone",
	["DUSTY03"]="stone",
	["DUSTY04"]="stone",
	["DUSTY05"]="stone",
	["DUSTY06"]="stone",
	["DUSTY07"]="stone",
	["DUSTY08"]="stone",
	["DUSTY09"]="stone",
	["DUSTY10"]="stone",
	["DUSTY11"]="stone",
	["DUSTY12"]="stone",
	["DUSTY13"]="stone",
	["DUSTY14"]="stone",
	["DUSTY15"]="stone",
	["DUSTY16"]="stone",
	["DUSTY17"]="stone",
	["DUSTY18"]="stone",
	["DUSTY19"]="stone",
	["DUSTY20"]="stone",
	["TEMP"]="stone",
	["TEMP2"]="stone",
	["WHITE01"]="snow",
	["WHITE02"]="snow",
	["WHITE03"]="snow",
	["WHITE04"]="snow",
	["WHITE05"]="snow",
	["WHITE06"]="stone",
	["WHITE07"]="glass",
	["WHITE08"]="metal",
	["WHITE09"]="stone",
	["WHITE10"]="stone",
	["WHITE11"]="stone",
	["WHITE12"]="stone",
	["WHITE13"]="stone",
	["WHITE14"]="stone",
	["WHITE15"]="stone",
	["WHITE16"]="stone",
	["WHITE17"]="stone",
	["WHITE18"]="stone",
	["WHITE19"]="stone",
	["CRISIS01"]="stone",
	["CRISIS02"]="stone",
	["CRISIS03"]="stone",
	["CRISIS04"]="stone",
	["CRISIS05"]="stone",
	["CRISIS06"]="water",
	["CRISIS07"]="metal",
	["CRISIS08"]="metal",
	["CRISIS09"]="metal",
	["CRISIS10"]="stone",
	["CRISIS11"]="stone",
	["CRISIS12"]="stone",
	["CRISIS13"]="stone",
	["CRISIS14"]="stone",
	["CRISIS15"]="stone",
	["CRISIS16"]="stone",
	["CRISIS17"]="dirt",
	["CRISIS18"]="dirt",
	["CRISIS19"]="metal",
	["CRISIS20"]="metal",
	["CRISIS21"]="stone",
	["CRISIS22"]="stone",
	["FLAMEC01"]="stone",
	["FLAMEC02"]="stone",
	["FLAMEC03"]="stone",
	["FLAMEC04"]="stone",
	["FLAMEC05"]="stone",
	["FLAMEC06"]="lava",
	["TRAIN01"]="dirt",
	["TRAIN02"]="stone",
	["TRAIN03"]="wood",
	["TRAIN04"]="wood",
	["TRAIN05"]="grass",
	["TRAIN06"]="grass",
	["TRAIN07"]="dirt",
	["TRAIN08"]="stone",
	["TRAIN09"]="stone",
	["TRAIN10"]="stone",
	["TRAIN11"]="dirt",
	["TRAIN12"]="dirt",
	["TRAIN13"]="metal",
	["TRAIN14"]="grass",
	["TRAIN15"]="grass",
	["TRAIN16"]="dirt",
	["TRAIN17"]="dirt",
	["TRAIN18"]="metal",
	["TRAIN19"]="metal",
	["TRAIN20"]="metal",
	["TRAIN21"]="stone",
	["TRAIN22"]="stone",
	["TRAIN23"]="stone",
	["TRAIN24"]="metal",
	["TRAIN25"]="metal",
	["TRAIN26"]="metal",
	["TRAIN27"]="metal",
	["TROPIC01"]="grass",
	["TROPIC02"]="grass",
	["TROPIC03"]="grass",
	["TROPIC04"]="grass",
	["TROPIC05"]="grass",
	["TROPIC06"]="wood",
	["TROPIC07"]="wood",
	["TROPIC08"]="stone",
	["TROPIC09"]="grass",
	["TROPIC10"]="grass",
	["TROPIC11"]="grass",
	["TROPIC12"]="wood",
	["TROPIC13"]="stone",
	["TROPIC14"]="stone",
	["TROPIC15"]="stone",
	["TROPIC16"]="wood",
	["TROPIC17"]="wood",
	["TROPIC18"]="stone",
	["KINVAL01"]="grass",
	["KINVAL02"]="grass",
	["KINVAL03"]="stone",
	["KINVAL04"]="grass",
	["KINVAL05"]="stone",
	["KINVAL06"]="stone",
	["KINVAL07"]="stone",
	["KINVAL08"]="stone",
	["KINVAL09"]="stone",
	["KINVAL10"]="stone",
	["KINVAL11"]="stone",
	["KINVAL12"]="stone",
	["KINVAL13"]="stone",
	["KINVAL14"]="grass",
	["KINVAL15"]="stone",
	["KINVAL16"]="stone",
	["KINVAL17"]="stone",
	["KINVAL18"]="stone",
	["KINVAL19"]="glass",
	["AQUA01"]="metal",
	["AQUA02"]="metal",
	["AQUA03"]="metal",
	["AQUA04"]="metal",
	["AQUA05"]="metal",
	["AQUA06"]="metal",
	["AQUA07"]="metal",
	["AQUA08"]="metal",
	["AQUA09"]="metal",
	["AQUA10"]="metal",
	["AQUA11"]="metal",
	["AQUA12"]="metal",
	["AQUA13"]="metal",
	["AQUA14"]="metal",
	["AQUA15"]="metal",
	["AQUA16"]="metal",
	["AQUA17"]="metal",
	["AQUA18"]="metal",
	["AQUA19"]="metal",
	["AQUA20"]="metal",
	--Murder Mystery addition
	["2FORTWL2"]="wood",
	["A-BRICK1"]="stone",
	["ACPULEY2"]="metal",
	["ACWOOD1"]="wood",
	["ACWOOD2"]="wood",
	["ACWOOD3"]="wood",
	["ACWOOD4"]="wood",
	["ACWOODB2"]="wood",
	["ACZRAILW"]="metal",
	["BRICK1W"]="stone",
	["BRICK2W"]="stone",
	["CEPLR01"]="stone",
	["CESTONB1"]="stone",
	["CESTONB2"]="stone",
	["CESTONB3"]="stone",
	["CESTONB4"]="stone",
	["CESTONB5"]="stone",
	["CESTONB6"]="stone",
	["CESTONB7"]="stone",
	["CESTONB8"]="stone",
	["CESTONB9"]="stone",
	["CETILB4"]="stone",
	["CETILD4"]="stone",
	["CETILE4"]="stone",
	["CEZRCK0"]="stone",
	["CHAINFEN"]="metal",
	["COMP1"]="metal",
	["DCASPHW"]="stone",
	["DCWAL22"]="stone",
	["DCWAL25"]="stone",
	["DCWAL27"]="stone",
	["DSSWIT4"]="stone",
	["DIRT1"]="dirt",
	["ERZRED1"]="metal",
	["ERZWAL17"]="metal",
	["ERZ_D0W0"]="metal",
	["F_METAL1"]="metal",
	["F_METAL2"]="metal",
	["GFZFNCC"]="wood",
	["GFZROOF"]="metal",
	["GLASSTEX"]="glass",
	["LIBRARYA"]="wood",
	["OLDROCKW"]="stone",
	["OLDW00A"]="stone",
	["ROCKY3"]="stone",
	["SFLR27"]="ground",
	["SPEC0D"]="stone",
	["SPEC0DB"]="stone",
	["SPEC1"]="stone",
	["SPEC2"]="stone",
	["SPEC3"]="stone",
	["SPEC4"]="stone",
	["SPEC5"]="stone",
	["SPEC6"]="stone",
	["SPEC7"]="stone",
	["THPIPE1"]="metal",
	["THPIPE2"]="metal",
	["THZ2FN6B"]="metal",
	["THZ2N14"]="metal",
	["THZ2N3H"]="metal",
	["THZMETL2"]="stone",
	["THZWALLF"]="metal",
	["THZWALLA"]="stone",
	["THZWAL07"]="metal",
	["THDOOR2B"]="stone",

	--FREEDOOM flats
	["A-CAMO1"]="metal",
	["A-WOOD1"]="wood",
	["AQF001"]="metal",
	["AQF003"]="metal",
	["AQF004"]="metal",
	["AQF009"]="metal",
	["AQF024"]="stone",
	["AQF026"]="stone",
	["AQF050"]="stone",
	["AQF051"]="stone",
	["AQF052"]="stone",
	["AQF056"]="stone",
	["AQF057"]="stone",
	["AQF067"]="stone",
	["AQF074"]="metal",
	["AQCONC18"]="stone",
	["AQRUST01"]="metal",
	["BASE"]="stone",
	["BRICK"]="stone",
	["CEIL4_1"]="cloth",
	["CEIL5_1"]="stone",
	["CONS1_1"]="metal",
	["CONS1_5"]="metal",
	["CONS1_7"]="metal",
	["CONS1_9"]="metal",
	["CRATINY"]="wood",
	["CRATOP1"]="wood",
	["CRATOP2"]="wood",
	["DOORTRAK"]="metal",
	["FDSTEP1"]="metal",
	["FDSTEP2"]="metal",
	["FLAT1"]="stone",
	["FLAT3"]="stone",
	["FLAT4"]="metal",
	["FLAT5"]="stone",
	["FLAT5_1"]="wood",
	["FLAT9"]="stone",
	["FLAT10"]="dirt",
	["FLAT19"]="stone",
	["FLAT20"]="stone",
	["FLAT22"]="metal",
	["FLAT23"]="metal",
	["FLOOR0_1"]="stone",
	["FLOOR0_3"]="stone",
	["FLOOR0_5"]="stone",
	["FLOOR3_3"]="stone",
	["FLOOR4_6"]="stone",
	["FLOOR5_2"]="stone",
	["GRAY1"]="stone",
	["GRAY2"]="stone",
	["GRAY3"]="stone",
	["GRAY4"]="stone",
	["GRAY5"]="stone",
	["GRAY6"]="stone",
	["GRAY7"]="stone",
	["GRAYBIG"]="stone",
	["MARBLE1"]="stone",
	["RROCK19"]="grass",
	["SLIME14"]="metal",
	--8-Ball Hotel textures
	["8BDOOR"]="wood",
	["8BGRASS"]="grass",
	["8BWALL0"]="stone",
	["8BWALL1"]="stone",
	["8BWALL4"]="stone",
	["8BWALL5"]="stone",
	["8BWALL7"]="stone"
}

local playeraniminfo={ --only Vanilla characters are left
	["sonic"]={
		["runFrames"]={0, 2},
		["dashFrames"]={-1},
		["walkFrames"]={3, 7},
		["waitFrames"]={0},
		["run"]=true,
		["dash"]=false,
		["walk"]=true,
		["idle"]=true,
		["wait"]=true,
	},["tails"]={
		["runFrames"]={-1},
		["dashFrames"]={-1},
		["walkFrames"]={3, 7},
		["waitFrames"]={-1},
		["run"]=false,
		["dash"]=false,
		["walk"]=true,
		["idle"]=true,
		["wait"]=false,
	},["knuckles"]={
		["runFrames"]={0, 2},
		["dashFrames"]={-1},
		["walkFrames"]={3, 7},
		["waitFrames"]={-1},
		["run"]=true,
		["dash"]=false,
		["walk"]=true,
		["idle"]=true,
		["wait"]=false,
	},["amy"]={
		["runFrames"]={2, 7},
		["dashFrames"]={-1},
		["walkFrames"]={3, 7},
		["waitFrames"]={1, 3},
		["run"]=true,
		["dash"]=false,
		["walk"]=true,
		["idle"]=true,
		["wait"]=true,
	},["fang"]={
		["runFrames"]={1, 4},
		["dashFrames"]={-1},
		["walkFrames"]={3, 7},
		["waitFrames"]={-1},
		["run"]=true,
		["dash"]=false,
		["walk"]=true,
		["idle"]=true,
		["wait"]=false,
	},["metal_sonic"]={
		["runFrames"]={-1},
		["dashFrames"]={-1},
		["walkFrames"]={-1},
		["waitFrames"]={-1},
		["run"]=false,
		["dash"]=false,
		["walk"]=false,
		["idle"]=true,
		["wait"]=false,
	}
}

for skin, animinfo in pairs(playeraniminfo)
	PlayerAnimInfo[skin]=animinfo
end
local function reset(player)
	if valid(player.mo)
		player.lastframe=0
		player.lastanim=nil
		player.playsound=false
		player.wasfalling=false
		player.variablesset=true
		player.groundtexture=nil
		player.lastgroundtexture=nil

		player.soundList=SoundListInfo["sonic"]
	end
end
local function has_value (tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end
local function getGroundTexture(mo)
    local result
    
    if (mo.eflags & MFE_VERTICALFLIP)
		if (mo.ceilingrover) result=mo.ceilingrover.bottompic
        elseif ((mo.standingslope) and (mo.standingslope == mo.subsector.sector.c_slope)) result=mo.subsector.sector.ceilingpic
        elseif (mo.ceilingz == mo.subsector.sector.ceilingheight) result=mo.subsector.sector.ceilingpic end
    else
        if (mo.floorrover) result=mo.floorrover.toppic
		elseif ((mo.standingslope) and (mo.standingslope == mo.subsector.sector.f_slope)) result=mo.subsector.sector.floorpic
        elseif (mo.floorz == mo.subsector.sector.floorheight) result=mo.subsector.sector.floorpic end
	end
	return result
end

addHook("PlayerThink", function(player)
	if (gametype!=GT_LTMMURDERMYSTERY) return end
	if (valid(player.mo)) and (player.mo.state != S_PLAY_DEAD) and (not player.spectator)
		local pmo = player.mo
		local panimInfo=PlayerAnimInfo[pmo.skin]
		if (panimInfo)
			if (not player.variablesset) reset(player) end
			player.groundtexture=getGroundTexture(pmo)
			if (not player.groundtexture) and (player.lastgroundtexture) player.groundtexture=player.lastgroundtexture end
			local material
			local soundType
			player.playsound=false

			local minHeight
			if (pmo.eflags & MFE_VERTICALFLIP)
				if (pmo.ceilingrover) minHeight = P_GetFOFBottomZAt(pmo.ceilingrover, pmo.x, pmo.y)
				else minHeight = P_GetSectorCeilingZAt(pmo.subsector.sector, pmo.x, pmo.y) end
			else
				--pmo.floorrover (and pmo.ceilingrover) does not nil when player's origin is not on FOF but instead stands on the edge of it. This leads to afwul results in a form of "poop flying marks" on FOF edges. Any way to fix this?
				if (pmo.floorrover) minHeight = P_GetFOFTopZAt(pmo.floorrover, pmo.x, pmo.y)
				else minHeight = P_GetSectorFloorZAt(pmo.subsector.sector, pmo.x, pmo.y) end
			end

			if ((pmo.z == minHeight) or ((pmo.standingslope) and (pmo.standingslope.zdelta < 32768))) --FU/2
				if not(player.wasfalling)
					if (player.skidtime==16)
						player.playsound=true
						soundType="skid"
					elseif not (player.powers[pw_carry])
						if pmo.state == S_PLAY_RUN
							player.playsound=panimInfo["run"] and (has_value(panimInfo["runFrames"], pmo.frame & FF_FRAMEMASK) or has_value(panimInfo["runFrames"], pmo.frame))
						elseif pmo.state == S_PLAY_DASH
							player.playsound=panimInfo["dash"] and (has_value(panimInfo["dashFrames"], pmo.frame & FF_FRAMEMASK) or has_value(panimInfo["dashFrames"], pmo.frame))
						elseif pmo.state == S_PLAY_WALK
							player.playsound=panimInfo["walk"] and (has_value(panimInfo["walkFrames"], pmo.frame & FF_FRAMEMASK) or has_value(panimInfo["walkFrames"], pmo.frame))
						elseif pmo.state == S_PLAY_STND or pmo.state == S_PLAY_EDGE
							player.playsound=panimInfo["idle"] and player.lastanim ~= player.panim
						elseif pmo.state == S_PLAY_WAIT 
							player.playsound=panimInfo["wait"] and (has_value(panimInfo["waitFrames"], pmo.frame & FF_FRAMEMASK) or has_value(panimInfo["waitFrames"], pmo.frame))
						end

						soundType="steps"
						player.playsound=player.playsound and player.lastframe ~= pmo.frame
						player.lastframe=pmo.frame
						player.lastanim=player.panim
					end
				else
					player.wasfalling=false
					player.playsound=true
					soundType="land"
				end
			elseif (not P_IsObjectOnGround(pmo))
				player.wasfalling=true
			end
			if (player.playsound) and (not player.mm.sneak)
				if not (pmo.eflags & MFE_GOOWATER)
					if (player.groundtexture) material=flatsounds[player.groundtexture] end
					if (not material) material="stone" end
					player.lastgroundtexture = player.groundtexture
					if (material) and (soundType) and (player.soundList[material]) and (player.soundList[material][soundType])
						local sounds = player.soundList[material][soundType]
						if (sounds)
							S_StartSound(pmo, sounds[P_RandomKey(#sounds) + 1])
							if (not SOC_IsTrue(mapheaderinfo[gamemap].mm_disablefootmarks) and footmarksCVAR.value)
								local mobjstep = P_SpawnMobjFromMobj(pmo,0,0,0,MT_MMSTEP)
								mobjstep.eflags = pmo.eflags
							end
						end
					end
				end
				if (pmo.eflags & MFE_TOUCHLAVA)
					local sounds=player.soundList["lava"][soundType]
					if (sounds) S_StartSound(pmo, sounds[P_RandomKey(#sounds) + 1]) end
				elseif (pmo.eflags & MFE_UNDERWATER) or (pmo.eflags & MFE_TOUCHWATER) or (pmo.eflags & MFE_GOOWATER)
					local sounds=player.soundList["water"][soundType]
					if (sounds) S_StartSound(pmo, sounds[P_RandomKey(#sounds) + 1]) end
				end
			end
		end
	end
end)


--Somewhat effective function to remove the "flying footmarks"
--The problem is, this function does not allow for footmarks to spawn on FOF surfaces and slopes

--addHook("MobjThinker", function(mo)
--	if (not P_IsObjectOnGround(mo)) then P_KillMobj(mo) end
--end, MT_MMSTEP)
